#include<bits/stdc++.h>
#define MAXN 500007
using namespace std;

struct event{
    int big;
    int how;
    int id;
};

const long long inf=1e9+7;

int n,q,l[MAXN],r[MAXN],cnt,ll,rr,tt,br[100007],minx[MAXN],maxx[MAXN],pt[MAXN],last[MAXN];
long long a[100007],ret[100007],p[MAXN],mid;

long long res[MAXN],pref[100007],ans[MAXN];

vector< pair<int,int> > w;
unordered_map<int,int> mp;
vector<event> qr[100007];

pair<int,int> tree[400007];

pair<int,int> combine(pair<int,int> fr,pair<int,int> sc){
    return { min(fr.first,sc.first) , max(fr.second,sc.second) };
}

void build(int v,int l,int r){
    if(l==r){
        tree[v]={a[l],a[l]};
    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

pair<int,int> getinfo(int v,int l,int r,int ll,int rr){
    if(ll>rr)return {inf,-1};
    if(l==ll and r==rr){
        return tree[v];
    }else{
        int tt=(l+r)/2;
        return combine( getinfo(2*v,l,tt,ll,min(tt,rr)) , getinfo(2*v+1,tt+1,r,max(tt+1,ll),rr) );
    }
}

long long fenwick[100007];

void update(int x,long long val){
    while(x<=cnt){
        fenwick[x]+=val;
        x+=(x & (-x));
    }
}

long long query(int x){
    long long e=0;
    while(x>=1){
        e+=fenwick[x];
        x-=(x & (-x));
    }
    return e;
}

int fenwick2[100007];

void update2(int x){
    while(x<=cnt){
        fenwick2[x]++;
        x+=(x & (-x));
    }
}

int query2(int x){
    int e=0;
    while(x>=1){
        e+=fenwick2[x];
        x-=(x & (-x));
    }
    return e;
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>n>>q;
    for(int i=1;i<=n;i++){
        cin>>a[i];
        pref[i]=pref[i-1]+a[i];
        w.push_back({a[i],0});
    }
    sort(w.begin(),w.end()); cnt=1;
    for(int i=0;i<w.size();i++){
        if(i>0 and w[i].first!=w[i-1].first)cnt++;
        w[i].second=cnt;
        mp[w[i].first]=cnt; ret[cnt]=w[i].first;
    }

    build(1,1,n);
    for(int i=1;i<=n;i++){
        a[i]=mp[a[i]];
    }

    for(int i=1;i<=q;i++){
        cin>>l[i]>>r[i]>>p[i];
        minx[i]=getinfo(1,1,n,l[i],r[i]).first-1;
        maxx[i]=getinfo(1,1,n,l[i],r[i]).second;
        ans[i]=(long long) maxx[i]*(r[i]-l[i]+1)-(pref[r[i]]-pref[l[i]-1]);
        qr[l[i]-1].push_back({0,0,0});
        qr[r[i]].push_back({0,0,0});
    }

    for(int i=1;i<=q;i++){
        last[i]=-1;
    }

    for(int i=1;i<=35;i++){
        for(int f=0;f<=n;f++){
            fenwick[f]=fenwick2[f]=0;
            pt[f]=0;
        }

        for(int f=1;f<=q;f++){
            mid=(minx[f]+maxx[f])/2;
            ll=-1; rr=int(w.size());
            while(ll+1<rr){
                tt=(ll+rr)/2;
                if(w[tt].first>=mid){
                    rr=tt;
                }else{
                    ll=tt;
                }
            }

            if(rr==last[f]){
                continue;
            }
            res[f]=br[f]=-1;
            last[f]=rr;

            if(rr>=1){
                qr[l[f]-1][pt[l[f]-1]]={w[rr].second,w[rr-1].second,f}; pt[l[f]-1]++;
                qr[r[f]][pt[r[f]]]={w[rr].second,w[rr-1].second,f}; pt[r[f]]++;
            }else{
                qr[l[f]-1][pt[l[f]-1]]={w[rr].second,0,f}; pt[l[f]-1]++;
                qr[r[f]][pt[r[f]]]={w[rr].second,0,f}; pt[r[f]]++;
            }
        }

        for(int f=0;f<=n;f++){
            if(f>0)update(a[f],ret[a[f]]);
            if(f>0)update2(a[f]);

            for(int k=0;k<qr[f].size();k++){
                if(res[qr[f][k].id]==-1){
                    res[qr[f][k].id]=query(cnt)-query(qr[f][k].big-1);
                }else{
                    res[qr[f][k].id]=(query(cnt)-query(qr[f][k].big-1))-res[qr[f][k].id];
                }

                if(br[qr[f][k].id]==-1){
                    br[qr[f][k].id]=query2(qr[f][k].how);
                }else{
                    br[qr[f][k].id]=query2(qr[f][k].how)-br[qr[f][k].id];
                }
            }
        }

        for(int f=1;f<=q;f++){
            mid=(minx[f]+maxx[f])/2;
            if((long long) 1000*(r[f]-l[f]+1)*mid>=(long long) p[f]*(res[f]+mid*br[f])){
                maxx[f]=mid;
                ans[f]=(long long) br[f]*mid-(pref[r[f]]-pref[l[f]-1]-res[f]);
            }else{
                minx[f]=mid;
            }
        }
    }

    for(int i=1;i<=q;i++){
        cout<<ans[i]<<"\n";
    }

    return 0;
}
