#include "lcm.h"
#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int MAX_N = 1e5 + 10;
bool prime[MAX_N];

std::vector<int> guessPermutation(int n) {
    prime[0] = prime[1] = true;
    vector<int> cool = {};
    for(int i = 1; i <= n; i ++) {
        if(prime[i]) { continue; }
        ll curr = 1;
        while(curr * (ll)i <= n) {
            curr *= i;
        }
        if(curr * 2 > n) {
            cool.push_back(curr);
        }
        for(int j = i * 2; j <= n; j += i) {
            prime[j] = false;
        }
    }

    int best_ind = {};
    int ped = -1;

    vector<int> indexes = {};
    for(int i = 1; i <= n; i ++) {
        indexes.push_back(i);
    }

    random_shuffle(indexes.begin(), indexes.end());

    for(int i = 0; i < indexes.size(); i ++) {
        int ind1 = indexes[i];
        int ind2 = indexes[(i + 1) % indexes.size()];
        int ind3 = indexes[(i + 2) % indexes.size()];
        int lcm1 = lcm(ind1, ind2);
        for(const auto it : cool) {
            if(lcm1 % it == 0) {
                ped = it;
                break;
            }
        }
        if(ped == -1) { continue; }
        int lcm2 = lcm(ind2, ind3);
        if(lcm2 % ped == 0) {
            best_ind = ind2;
        } else {
            best_ind = ind1;
        }
    }

    vector<int> ret = {};
    for(int i = 1; i <= n; i ++) {
        if(i == best_ind) {
            ret.push_back(ped);
        } else {
            ret.push_back(lcm(i, best_ind) / ped);
        }
    }

    return ret;
}
