#include "lcm.h"
#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const ll MAX_N = 1e5 + 10;
bool prime[MAX_N];

void init() {
    prime[0] = prime[1] = true;
    for(ll i = 1; i < MAX_N; i ++) {
        if(prime[i]) { continue; }
        for(ll j = i * 2; j < MAX_N; j += i) {
            prime[j] = true;
        }
    }
}

std::vector<ll> guessPermutation(ll n) {
    if(!prime[0]) {
        init();
    }

    vector<ll> cool = {};
    for(ll i = 1; i <= n; i ++) {
        if(prime[i]) { continue; }
        ll curr = i;
        if(curr * 2 > n) {
            cool.push_back(curr);
        }
    }

    ll best_ind = 0;
    ll ped = -1;

    vector<ll> indexes = {};
    for(ll i = 1; i <= n; i ++) {
        indexes.push_back(i);
    }

    random_shuffle(indexes.begin(), indexes.end());

    for(ll i = 0; i < indexes.size(); i ++) {
        ll ind1 = indexes[i];
        ll ind2 = indexes[(i + 1) % indexes.size()];
        ll lcm1 = lcm(ind1, ind2);
        if(ped != -1) {
            if(lcm1 % ped == 0) {
                best_ind = ind1;
            } else {
                best_ind = indexes[(i - 1 + indexes.size()) % indexes.size()];
            }
            break;
        }

        for(const auto it : cool) {
            if(lcm1 % it == 0) {
                ped = it;
                continue;
            }
        }
    }

    vector<ll> ret = {};
    for(ll i = 1; i <= n; i ++) {
        if(i == best_ind) {
            ret.push_back(ped);
        } else {
            ret.push_back(lcm(i, best_ind) / ped);
        }
    }

    return ret;
}

/*
4
1
2 3 1 4
*/
