/**
    Happy birthday
    Рагадагадактак
    Рагадагадактак
*/

#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 100000 + 10;
const int INF  = 1e9;

int n, q;
int a[MAXN];

bool check(int l, int r, int p, int val)
{
    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(val, a[i]);
    }

    return sum * p <= 1000LL * val * (r - l + 1);
}

llong query(int l, int r, int p)
{
    int ll = -1, rr = INF, mid;
    while (ll < rr - 1)
    {
        mid = (ll + rr) / 2;
        if (!check(l, r, p, mid)) ll = mid;
        else rr = mid;
    }

    llong sum = 0;
    for (int i = l ; i <= r ; ++i)
    {
        sum += std::max(0, rr - a[i]);
    }

    return sum;
}

void solve()
{
    for (int i = 1 ; i <= q ; ++i)
    {
        int l, r, p;
        std::cin >> l >> r >> p;
        std::cout << query(l, r, p) << '\n';
    }
}

void input()
{
    std::cin >> n >> q;
    for (int i = 1 ; i <= n ; ++i)
    {
        std::cin >> a[i];
    }
}

void fastIOI()
{
    std::ios_base :: sync_with_stdio(0);
    std::cout.tie(nullptr);
    std::cin.tie(nullptr);
}

int main()
{
    fastIOI();
    input();
    solve();

    return 0;
}

// -WI,-stack 268435456
