#include<bits/stdc++.h>
#include "lcm.h"

using namespace std;
typedef long long ll;

bool prime(int x)
{
    for (int i = 2; i <= sqrt(x); i ++)
    {
        if (x % i == 0)
            return false;
    }
    return true;
}

const int maxn = 1e5 + 10;

ll val[maxn];
vector<int> guessPermutation(int n)
{
    vector < int > res(n);

    ll num = 0;
    for (int i = 2; i <= n; i ++)
    {
        val[i] = lcm(1, i);
        num = __gcd(num, val[i]);
    }

    ll big = n;
    while(!prime(big))
        big --;

    int pos = -1;
    for (int i = 2; i <= n; i ++)
    {
        if (val[i] == num * big)
            pos = i;
    }

    if (pos == -1)
        pos = 1;
    for (int i = 1; i <= n; i ++)
    {
        if (pos != i)
            res[i - 1] = lcm(pos, i) / big;
        else
            res[i - 1] = big;
    }
    return res;
}
