#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 5e5 + 10;

ll n, q;
ll a[maxn];


ll solve_query(ll l, ll r, double c)
{
    ll sum = 0;
    vector < ll > val;

    for (ll i = l; i <= r; i ++)
        sum += a[i], val.push_back(a[i]);

    sort(val.begin(), val.end());

    double cs = c / (double)(r - l + 1);
    ll step = 0;
    ll lf = 1, rf = (int)(val.size()) - 1;
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2;
        ll pref = 0;
        for (int i = 0; i < mf; i ++)
            pref = pref + val[i];
        ll act = mf * val[mf] - pref + sum;
        if (val[mf] / (double)(act) < cs)
            lf = mf + 1;
        else
            rf = mf - 1;
    }

    ll i = lf;
    ll pref = 0;
    for (int j = 0; j < i; j ++)
        pref = pref + val[j];
    sum = sum - pref + i * (val[i - 1]);
    step = step + (i * val[i - 1]) - pref;
    ///cout << sum << " " << step << " : " << i << " " << pref << endl;
    /**for (ll i = 1; i < val.size(); i ++)
    {
        ll nec = (val[i] - val[i - 1]) * (i);
        if ((double)val[i] / (double)(sum + nec) < cs)
        {
            sum = sum + nec;
            step = step + nec;
            continue;
        }*/

        lf = 0;
         rf = (val[i] - val[i - 1]);
        while(lf <= rf)
        {
            ll mf = (lf + rf) / 2;
            double cur = (double)(val[i - 1] + mf) / (double)(sum + mf * i);
            if (cur >= cs)
                rf = mf - 1;
            else
                lf = mf + 1;
        }
        step = step + i * lf;

        /**ll to_add = ceil((double)(val[i - 1] - cs * sum) / (double)(cs * i - 1));
        sum = sum + to_add * i;
        step = step + to_add * i;*/

    /*        break;
    }*/
    return step;
}
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];

    for (ll i = 1; i <= q; i ++)
    {
        ll l, r, p;
        cin >> l >> r >> p;
        double c = p / 1000.0;
        cout << solve_query(l, r, c) << endl;
    }
}

int main()
{
    solve();
    return 0;
}
/**
10 1
2 8 5 1 10 5 9 9 3 5
2 7 800
*/
