#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 5e5 + 10;

ll n, q;
ll a[maxn];


ll solve_query(ll l, ll r, double c)
{

    ll lf = 0, rf = 1e9;
    double cs = c / (double)(r - l + 1);
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2, sum = 0;
        for (ll i = l; i <= r; i ++)
        {
            sum = sum + max(mf, a[i]);
        }
        ///cout << lf << " " << rf << " " << (double)(mf) / (double)(sum) << endl;
        if ((double)(mf) / (double)(sum) >= cs)
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    ll step = 0;
    for (int i = l; i <= r; i ++)
        step = step + max((ll)(0), lf - a[i]);
    return step;
}
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];

    for (ll i = 1; i <= q; i ++)
    {
        ll l, r, p;
        cin >> l >> r >> p;
        double c = p / 1000.0;
        cout << solve_query(l, r, c) << endl;
    }
}

int main()
{
    solve();
    return 0;
}
/**
10 1
2 8 5 1 10 5 9 9 3 5
2 7 800
*/
