#include<bits/stdc++.h>
#define endl '\n'

using namespace std;
typedef long long ll;

void speed()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}
const ll maxn = 1e5 + 10, maxq = 5e5 + 10;

ll block;
ll n, q;
ll a[maxn];

struct query
{
    ll l, r, idx;
    ll c;
} ask[maxq];

bool cmp(const query &q1, const query & q2)
{
    if (q1.l / block == q2.l / block)
        return q1.r < q2.r;
    return q1.l / block < q2.l / block;
}

vector < pair < ll, ll > > val;
ll pos[maxn];
pair < ll, ll > fen[maxn];

struct node
{
    ll sum, act, rtm;
};

node tree[4 * maxn];
void toggle(ll root, ll left, ll right, ll pt)
{
    while(left != right)
    {
        int mid = (left + right) / 2;
        if (pt <= mid)
        {
            root = root * 2;
            right = mid;
        }
        else
        {
            root = root * 2 + 1;
            left = mid + 1;
        }
    }
    if (tree[root].act == 0)
    {
        tree[root].act = 1;
        tree[root].sum = val[left - 1].first;
        tree[root].rtm = left;
    }
    else
    {
        tree[root].act = 0;
        tree[root].sum = 0;
        tree[root].rtm = 0;
    }

    root /= 2;
    while(root > 0)
    {

        tree[root].sum = tree[root * 2].sum + tree[root * 2 + 1].sum;
        tree[root].act = tree[root * 2].act + tree[root * 2 + 1].act;
        tree[root].rtm = tree[root * 2 + 1].rtm;
        if (tree[root].rtm == 0)
            tree[root].rtm = tree[root * 2].rtm;
        root /= 2;
    }
}

ll sum_all, len_all;
ll walk(ll root, ll left, ll right, pair < ll, ll > bef, ll c)
{
    ///cout << root << " " << left << " " << right << " " << bef.first << " " << bef.second << endl;
    if (left == right)
    {
        return left;
    }

    ll mid = (left + right) / 2;
    if (tree[root * 2].rtm == -1)
        return walk(root * 2, mid + 1, right, bef, c);
    ll mx = val[tree[root * 2].rtm - 1].first;
    ///cout << tree[root * 2].rtm << endl;
    ll bef_sum = bef.first + tree[root * 2].sum;
    ll bef_act = bef.second + tree[root * 2].act;
    ll sum = sum_all - bef_sum + bef_act * mx;
    if (sum * c <= (ll)1000 * (mx * (len_all)))
        return walk(root * 2, left, mid, bef, c);
    return walk(root * 2 + 1, mid + 1, right, {bef_sum, bef_act}, c);
}

void update_fen(ll st, ll x, ll tp)
{

    for (ll i = st; i <= n; i += (i & -i))
    {

        fen[i].first += x;
        fen[i].second += tp;
    }
}

pair < ll, ll > query(ll st)
{
    ll s = 0, t = 0;
    for (ll i = st; i > 0; i -= (i & -i))
    {
        s += fen[i].first;
        t += fen[i].second;
    }
    return {s, t};
}

ll get_pos(ll x)
{
    ll lf = 0, rf = n - 1;
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2;
        ///cout << lf << " : " << rf << endl;
        if (val[mf].first >= x)
            rf = mf - 1;
        else
            lf = mf + 1;
    }
    return lf ;
}
ll find_bef(ll root, ll left, ll right, ll qleft, ll qright)
{

    if (left > qright || right < qleft || tree[root].act == 0)
        return -1;

    if (left == right)
        return left;
    ll mid = (left + right) / 2;
    if (left >= qleft && right <= qright)
    {
        if (tree[root * 2 + 1].act != 0)
            return find_bef(root * 2 + 1, mid + 1, right, qleft, qright);
        return find_bef(root * 2, left, mid, qleft, qright);
    }

    return max(find_bef(root * 2, left, mid, qleft, qright),
               find_bef(root * 2 + 1, mid + 1, right, qleft, qright));
}

pair < ll, ll > query_pref(ll root, ll left, ll right, ll qleft, ll qright)
{
    if (left > qright || right < qleft)
        return {0, 0};

    if (left >= qleft && right <= qright)
        return {tree[root].sum, tree[root].act};

    ll mid = (left + right) / 2;
    pair <ll, ll > f = query_pref(root * 2, left, mid, qleft, qright);
    pair < ll, ll > t=  query_pref(root * 2 + 1, mid + 1, right, qleft, qright);
    return {f.first + t.first, f.second + t.second};
}

ll solve_query(ll l, ll r, ll c)
{


    ll wh = walk(1, 1, n, {0, 0}, c);
    ll ds = find_bef(1, 1, n, 1, wh - 1);
    /**cout << wh << endl;
    for (int i = 1; i <= n; i ++)
        cout << val[i - 1].first << " ";
    cout << endl;*/
    if (ds == -1)
        return 0;
    pair < ll, ll > cur = query_pref(1, 1, n, 1, wh - 1);
    ll lf = val[ds - 1].first, rf = val[wh - 1].first;
    ///cout << lf << " : " << rf << endl;
    while(lf <= rf)
    {
        ll mf = (lf + rf) / 2;
        ll sum = sum_all - cur.first + cur.second * mf;
        if ((ll)(mf * (r - l + 1)) * (ll)(1000) >= (ll)(c * sum))
            rf = mf - 1;
        else
            lf = mf + 1;
    }
    ll step = max((ll)(0), cur.second * lf - cur.first);
    return step;

    //cout << wh << endl;
    /**while(lf <= rf)
    {

        ll mf = (lf + rf) / 2;
        ll gt = get_pos(mf);

        pair < ll, ll > imp = query(gt);
        ll sum = query(n).first - imp.first + imp.second *  mf;
        ///cout << mf << " " << gt << " " << sum << " " << query(n).first << " " << imp.first << " " << imp.second << endl;
        ///cout << imp.first << " " << imp.second << " " << sum << " " << mf << endl;

        ///cout << lf << " " << rf << " " << (double)(mf) / (double)(sum) << " " << cs << endl;
        if ((ll)(mf * (r - l + 1)) * (ll)(1000) >= (ll)(c * sum))
            rf = mf - 1;
        else
            lf = mf + 1;
    }

    ll gt = get_pos(lf);

    pair < ll, ll > imp = query(gt);
    ll step = max((ll)(0), imp.second * lf - imp.first);
    return step;*/
    return 0;
}

ll lf = 1, rf = 0;
void update(ll l, ll r)
{
    while(rf < r)
    {
        rf ++;
        len_all ++;
        sum_all += a[rf];
        toggle(1, 1, n, pos[rf]);
    }

    while(lf > l)
    {
        lf --;
        len_all ++;
        sum_all += a[lf];
        toggle(1, 1, n, pos[lf]);

    }

    while(rf > r)
    {
        sum_all -= a[rf];
        len_all --;
        toggle(1, 1, n, pos[rf]);
        rf --;
    }

    while(lf < l)
    {
        sum_all -= a[lf];
        len_all --;
        toggle(1, 1, n, pos[lf]);
        lf ++;
    }
}

ll ans[maxq];
void solve()
{
    cin >> n >> q;
    for (ll i = 1; i <= n; i ++)
        cin >> a[i];
    block = sqrt(n);
    for (ll i = 1; i <= n; i ++)
        val.push_back({a[i], i});

    sort(val.begin(), val.end());

    for (ll i = 0; i < n; i ++)
        pos[val[i].second] = i + 1;

    for (ll i = 1; i <= q; i ++)
    {
        ll l, r, p;
        cin >> l >> r >> p;

        ask[i].l = l;
        ask[i].r = r;
        ask[i].c = p;
        ask[i].idx = i;
    }


    sort(ask + 1, ask + q + 1, cmp);
    for (ll i = 1; i <= q; i ++)
    {
        update(ask[i].l, ask[i].r);

        ans[ask[i].idx] = solve_query(ask[i].l, ask[i].r, ask[i].c);
    }

    for (ll i = 1; i <= q; i ++)
        cout << ans[i] <<endl;
}

int main()
{
    speed();
    solve();
    return 0;
}
/**
3 1
3 2 1
3 3 1000

*/


/**
5 1
8 3 4 5 2
1 5 900

10 1
2 8 5 1 10 5 9 9 3 5
1 5 597
*/
