#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=5e5+6;
struct node
{
    ll max1,hm1;
    ll max2,hm2;
    ll sum;
};
node merge1(node t1,node t2)
{
    set<ll>s;
    s.insert(-t1.max1);
    s.insert(-t1.max2);
    s.insert(-t2.max1);
    s.insert(-t2.max2);
    node ret;
    ret.max1=-(*s.begin());
    if(s.size()==1)
    {
        ret.max2=ret.max1;
    }
    else
    {
        s.erase(s.begin());
        ret.max2=-(*s.begin());
    }
    ret.hm1=0;
    ret.hm2=0;
    if(t1.max1==ret.max1)
    {
        ret.hm1+=t1.hm1;
    }
    if(t2.max1==ret.max1)
    {
        ret.hm1+=t2.hm1;
    }
    if(ret.max2!=ret.max1)
    {
        if(t1.max1==ret.max2)
        {
            ret.hm2+=t1.hm1;
        }
        if(t2.max1==ret.max2)
        {
            ret.hm2+=t2.hm1;
        }
        if(t1.max2==ret.max2)
        {
            ret.hm2+=t1.hm2;
        }
        if(t2.max2==ret.max2)
        {
            ret.hm2+=t2.hm2;
        }
    }
    ret.sum=t1.sum+t2.sum;
    return ret;
}
ll a[MAXN],n,q;
struct segment_tree
{
    node tree[3*MAXN];
    ll lazy[3*MAXN];
    void build(ll l,ll r,ll idx)
    {
        if(l==r)
        {
            tree[idx].max1=a[l];
            tree[idx].max2=a[l];
            tree[idx].sum=a[l];
            tree[idx].hm1=1;
            tree[idx].hm2=0;
            return;
        }
        lazy[idx]=0;
        ll mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=merge1(tree[idx*2], tree[idx*2+1]);
    }
    void push(ll l,ll r,ll idx)
    {
        if(lazy[idx]==0)return;
        if(tree[idx].max1<=lazy[idx])
        {
            tree[idx].max1=lazy[idx];
            tree[idx].hm1=(r-l+1);
            tree[idx].sum=(r-l+1)*lazy[idx];
        }
        else if(tree[idx].max2<=lazy[idx])
        {
            tree[idx].max2=lazy[idx];
            tree[idx].hm2=(r-l+1)-tree[idx].hm1;
            tree[idx].sum=tree[idx].hm1*tree[idx].max1+tree[idx].hm2*tree[idx].max2;
            //cout<<"^^ "<<tree[idx].sum<<" "<<tree[idx].hm1<<" "<<tree[idx].hm2<<" "<<tree[idx].max1<<" "<<tree[idx].max2<<endl;
        }
        if(l!=r)
        {
            lazy[idx*2]=max(lazy[idx*2],lazy[idx]);
            lazy[idx*2+1]=max(lazy[idx*2+1],lazy[idx]);
        }
        lazy[idx]=0;
    }
    void update(ll l,ll r,ll idx,ll ql,ll qr,ll val)
    {
        push(l,r,idx);
        if(l>qr)return;
        if(r<ql)return;
        if(l>=ql&&r<=qr)
        {
            if(tree[idx].max2<=val)
            {
                lazy[idx]=max(lazy[idx],val);
                push(l,r,idx);
                return;
            }
        }
        if(l==r)return;
        ll mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,val);
        update(mid+1,r,idx*2+1,ql,qr,val);
        tree[idx]=merge1(tree[idx*2],tree[idx*2+1]);
    }
    node query(ll l,ll r,ll idx,ll ql,ll qr)
    {
        push(l,r,idx);
        //cout<<"&& "<<l<<" "<<r<<" "<<tree[idx].sum<<endl;
        if(l>=ql&&r<=qr)return tree[idx];
        ll mid=(l+r)/2;
        if(qr<=mid)return query(l,mid,idx*2,ql,qr);
        if(ql>mid)return query(mid+1,r,idx*2+1,ql,qr);
        return merge1(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
}ogi;
struct query
{
    ll l,r;
    ll c;
};
query zaqvka[MAXN];
ll low[MAXN];
ll high[MAXN];
ll ans[MAXN];
vector<pair<ll,ll> >to_check;
void read()
{
    cin>>n>>q;
    for(ll i=1;i<=n;i++)
    {
        cin>>a[i];
    }
    for(ll i=1;i<=q;i++)
    {
        ll l1,r1,c;
        cin>>l1>>r1>>c;
        zaqvka[i].l=l1;
        zaqvka[i].r=r1;
        zaqvka[i].c=c;
        low[i]=1;high[i]=1000000000;
    }
}
ll sum_ans[MAXN];
int main()
{
    read();

    for(ll step=0;step<60;step++)
    {
        for(ll i=1;i<=q;i++)
        {
            if(low[i]<=high[i])
            {
                ll mid=(low[i]+high[i])/2;
                to_check.push_back({mid,i});
            }
        }
        sort(to_check.begin(),to_check.end());
        ogi.build(1,n,1);
        for(auto xd:to_check)
        {
            ogi.update(1,n,1,1,n,xd.first);
            ll l=zaqvka[xd.second].l;
            ll r=zaqvka[xd.second].r;
            ll c=zaqvka[xd.second].c;
            //cout<<xd.first<<" "<<xd.second<<":\n";
            ll sum1=ogi.query(1,n,1,l,r).sum;
            if(sum1*c>xd.first*(r-l+1ll)*1000ll)
            {
                //cout<<xd.first<<" "<<xd.second<<" bruh1\n";
                //cout<<sum1<<" "<<xd.first<<" "<<(long double)1.0*sum1/(r-l+1.0)*c<<endl;
                low[xd.second]=xd.first+1;
            }
            else
            {
                //cout<<xd.first<<" "<<xd.second<<" bruh2\n";
                //cout<<sum1<<" "<<xd.first<<" "<<(long double)1.0*sum1/(r-l+1.0)*c<<endl;
                ans[xd.second]=xd.first;
                sum_ans[xd.second]=sum1;
                high[xd.second]=xd.first-1;
            }
        }
        to_check.clear();
    }
    ogi.build(1,n,1);
    for(ll i=1;i<=q;i++)
    {
        ll l=zaqvka[i].l;
        ll r=zaqvka[i].r;
        ll sum1=ogi.query(1,n,1,l,r).sum;
        cout<<max(0ll,sum_ans[i]-sum1)<<endl;
    }
return 0;
}
