#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=5e5+6;

ll a[MAXN],n,q,op=0;
struct BIT
{
    int fen[MAXN];
    void init()
    {
        memset(fen,0,sizeof(fen));
    }
    int query(int idx)
    {
        idx++;
        int ret=0;
        for(;idx>0;idx-=idx&(-idx))
        {
            ret+=fen[idx];
        }
        return ret;
    }
    void update(int idx,int val)
    {
        idx++;
        for(;idx<MAXN;idx+=idx&(-idx))
        {
            fen[idx]+=val;
        }
    }
}fen0,fensum;
struct query
{
    ll l,r;
    ll c;
};
query zaqvka[MAXN];
ll low[MAXN];
ll high[MAXN];
ll ans[MAXN];
vector<ll>to_check[MAXN];
void fake_read()
{
    n=5000;q=5000;
    for(int i=1;i<=n;i++)
    {
        a[i]=rand()%1000000000ll+1ll;
        //cout<<a[i]<<" ";
    }
    //cout<<endl;
    for(int i=1;i<=q;i++)
    {
        ll l1,r1,c;

        c=rand()%1001;
        l1=rand()%n+1;r1=rand()%n+1;
        if(l1>r1)swap(l1,r1);

        zaqvka[i].l=l1;
        zaqvka[i].r=r1;
        zaqvka[i].c=c;
        //cout<<l1<<" "<<r1<<" "<<c<<endl;
        low[i]=1;high[i]=1000000000ll;
    }
}
vector<pair<int,int> >values;
void read()
{
    cin>>n>>q;
    values.push_back({0,0});
    for(ll i=1;i<=n;i++)
    {
        cin>>a[i];
        values.push_back({a[i],i});
    }
    sort(values.begin(),values.end());
    for(ll i=1;i<=q;i++)
    {
        ll l1,r1,c;
        cin>>l1>>r1>>c;
        zaqvka[i].l=l1;
        zaqvka[i].r=r1;
        zaqvka[i].c=c;
        low[i]=0;high[i]=values.size()-1;
    }
}
ll ans_slow[MAXN];
void solve_slow()
{
    for(int i=1;i<=q;i++)
    {
        multiset<ll>v;
        ll sum=0,len=0;
        for(int j=zaqvka[i].l;j<=zaqvka[i].r;j++)
        {
            len++;
            sum+=a[j];
            v.insert(a[j]);
        }
        ll cnt=0;
        for(;;)
        {
            //cout<<(*v.begin())<<" "<<sum<<" "<<cnt<<endl;
            if(sum*zaqvka[i].c<=(*v.begin())*len*1000ll)
            {
                break;
            }
            int t=(*v.begin());
            v.erase(v.find(t));
            ++t;
            v.insert(t);
            ++sum;
            ++cnt;
        }
        ans_slow[i]=cnt;
    }
}
ll sum_ans[MAXN];
ll pref[MAXN];
int main()
{
    read();
    //fake_read();

    for(ll step=0;step<19;step++)
    {
        op=0;
        //cout<<"new step\n";
        //cout<<"====================\n\n";
        fen0.init();
        fensum.init();
        for(int i=1;i<=n;i++)
        {
            fensum.update(i,a[i]);
        }
        for(ll i=1;i<=q;++i)
        {
            if(low[i]<=high[i])
            {
                ll mid=(low[i]+high[i])/2;
                to_check[mid].push_back(i);
            }
        }
        for(int i=0;i<values.size();i++)
        {
            if(i!=0)
            {
                fensum.update(values[i].second,-values[i].first);
                fen0.update(values[i].second,+1);
            }
            for(auto xd:to_check[i])
            {
                ll l=zaqvka[xd].l,r=zaqvka[xd].r,c=zaqvka[xd].c;
                ll sum1=fensum.query(r)-fensum.query(l-1);
                sum1+=(fen0.query(r)-fen0.query(l-1))*values[i].first;
                if(sum1*c>values[i].first*(r-l+1ll)*1000ll)
                {
                    low[xd]=i+1;
                }
                else
                {
                    high[xd]=i-1;
                    ans[xd]=i;
                    sum_ans[xd]=sum1;
                }
            }
        }
        //cout<<"op="<<op<<endl;
    }
    //solve_slow();
    for(int i=1;i<=n;i++)
    {
        pref[i]=pref[i-1]+a[i];
    }
    for(ll i=1;i<=q;++i)
    {
        ll l=zaqvka[i].l;
        ll r=zaqvka[i].r;
        ll sum1=pref[r]-pref[l-1];
        cout<<max(0ll,sum_ans[i]-sum1)<<endl;
        //cout<<i<<": "<<max(0ll,sum_ans[i]-sum1)<<" "<<ans_slow[i]<<"\n";
    }
return 0;
}
