#include<bits/stdc++.h>
#include "lcm.h"
using namespace std;

const int MAXN=1e5+5;

mt19937 mt(time(NULL));
int lcm_next[MAXN];
vector<int> a;
bool used[MAXN];
int perm[MAXN];

std::vector<int> guessPermutation(int n)
{
    a.resize(n);
    for(int i=1;i<n;i++)
    {
        lcm_next[i]=lcm(i,i+1);
    }
    lcm_next[0]=lcm_next[n]=lcm(1,n);

    for(int i=0;i<n;i++)
    {
        a[i]=__gcd(lcm_next[i],lcm_next[i+1]);
    }

    //for(int i=0;i<n;i++) cout<<a[i]<<" "; cout<<endl;
    for(int i=1;i<=n;i++) perm[i]=i;
    bool fl=1;
    for(int i=1;i<=n;i++) used[i]=0;
    for(int i=0;i<n;i++)
    {
        if(used[a[i]] || a[i]>n) {fl=0; break;}
        used[a[i]]=1;
    }
    while(fl==0)
    {
        shuffle(perm+1,perm+n+1, mt);
        for(int i=1;i<n;i+=2)
        {
            int x=lcm(perm[i],perm[i+1]);
            a[perm[i]-1]=__gcd(a[perm[i]-1],x);
            a[perm[i+1]-1]=__gcd(a[perm[i+1]-1],x);
        }

        fl=1;
        for(int i=1;i<=n;i++) used[i]=0;
        for(int i=0;i<n;i++)
        {
            if(used[a[i]] || a[i]>n) {fl=0;break;}
            used[a[i]]=1;
        }
    }
    //for(int i=0;i<n;i++) cout<<a[i]<<" "; cout<<endl;
    return a;
}
