#include <iostream>
#include <array>
#include <tuple>

//#include "Lgrader.cpp"
// (!)       MemoryOperation  work.      0  (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

//      work,     "std::array<MemoryOperation, 5>"   5 .
//        "MemoryOperation",          :
// MemoryOperation(SET_VAL, 0, 1) ->  "SET_VAL"    0   1 (memory[0] = 1)
// MemoryOperation(ADD_VAL, 0, 1) ->  "ADD_VAL"    0   1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

//     ,      constexpr.
constexpr int helper() {
    return 42;
}


//   constexpr,        .       .
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];

    //        .         :
    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };
    if(m==n-1) ret = {
        MemoryOperation(SET_VAL, 0, ANSWER_CONNECTED),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };
    else ret = {
        MemoryOperation(SET_VAL, 0, ANSWER_NOT_CONNECTED),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };

    //         u   :
    //    std::array,       ({}    ):
    //     ,   constexpr.
    return ret;
}
