#include<bits/stdc++.h>
using namespace std;
// (!) Не трябва да променяте дефинициите на MemoryOperation и work. В противен случай ще получите 0 точки (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

// За да върнете резултат от work, трябва да върнете масив "std::array<MemoryOperation, 5>" с точно 5 елемента.
// Всеки елемент на масива е от тип "MemoryOperation", като всеки елемент може да се инициализира по следния начин:
// MemoryOperation(SET_VAL, 0, 1) -> създава "SET_VAL" операция на клетка 0 със стойност 1 (memory[0s] = 1)
// MemoryOperation(ADD_VAL, 0, 1) -> създава "ADD_VAL" операция на клетка 0 със стойност 1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

// Функцията е constexpr, което не ви позволява да използвате глобална памет. Можете да използвате само параметрите на функцията.
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    const unsigned int n = memory[1];
    unsigned int m = memory[2];

    // Васички масиви които използваме трябва да се инициализират. Това е примерна инициализация на масива който ще върнем:
    std::array<MemoryOperation, 5> ret = {
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
        MemoryOperation(SET_VAL, memory_size - 1, 0u),
    };

    int upd=0;
    int isall=1;
    int hasubeenvisited=0;
    std::array<int, n+1> ret;
    for(unsigned int i=3;i<memory_size;i+=5) {
        int who=memory[i];
        int visited=memory[i+1];
        int updated=memory[i+2];
        hasvisited[who]=visited;
        if(updated==1)upd=1;
        if(visited==0)isall=0;
        if(who==u)hasubeenvisited=visited;
    }
    if(upd==0) {
        if(isall==1)memory[0]=1;
        else memory[0]=2;
        return ret;
    }
    ret[0]=MemoryOperation(SET_VAL, memory_size - 1, u);
    ret[1]=MemoryOperation(SET_VAL, memory_size - 1, hasubeenvisited);
    if(hasubeenvisited==1){ret[2]=MemoryOperation(SET_VAL, memory_size - 1, 0);return ret;}

    // Може да итерирате през всички съседи на върха u по следния начин:
    for (unsigned int i = 0; i < number_neighbours; ++i) {
        unsigned int v = neighbours[i];
        if(hasvisited[v]==1) {
            ret[2]=MemoryOperation(SET_VAL, memory_size - 1, 1u);
            ret[1]=MemoryOperation(SET_VAL, memory_size - 1, 1u);
            return ret;
        }
    }
    return ret;
}
