#include "lcm.h"
#include <iostream>
#include <vector>
#pragma optimize ("oss4")
using namespace std;
const int MAXN=1e5+10;
int que[MAXN];
long long NOD(long long a, long long b) {
    if (a==0) return b;
    if (b==0) return a;
    return NOD(b,a%b);
}
bool isprime(int x) {
    for (int i=2;i*i<=x;i++) {
        if (x%i==0) return false;
    }
    return true;
}
int find_prime(int n) {
    for (int i=n;i>=2;i--) {
        if (isprime(i)) return i;
    }
}
vector <int> guessPermutation(int n) {
    vector <int> ans;
    if (n==1) {
        ans.push_back(1);
        return ans;
    }
    for (int i=1;i<=n;i++) ans.push_back(i);
    return ans;
    long long cur=0;
    int pr=find_prime(n);
    cout << pr << endl;
    for (int i=2;i<=n;i++) {
        que[i]=lcm(1,i);
        cur=NOD(cur,que[i]);
    }
    ans.push_back(cur);
    if (cur==1) {
        for (int i=2;i<=n;i++) ans.push_back(que[i]);
        return ans;
    }
    int ind;
    if (cur==pr) ind=1;
    else {
        for (int i=2;i<=n;i++) {
            if (que[i]==cur*pr) {
                ind=i;
                break;
            }
        }
    }
    for (int i=2;i<=n;i++) {
        if (i==ind) ans.push_back(pr);
        else ans.push_back(lcm(ind,i)/pr);
    }
    return ans;
}
