#include "lcm.h"
#include <iostream>
#include <vector>
#pragma optimize ("oss4")
using namespace std;
const int MAXN=1e5+10;
bool er[MAXN];
long long que[MAXN];
long long NOD(long long a, long long b) {
    if (a==0) return b;
    if (b==0) return a;
    return NOD(b,a%b);
}
void eratosten(int n) {
    for (int i=2;i<=n;i++) {
        if (!er[i]) {
            for (int j=2*i;j<=n;j+=i) er[j]=true;
        }
    }
}
int find_prime(int n) {
    for (int i=n;i>=2;i--) {
        if (!er[i]) return i;
    }
}
vector <int> guessPermutation(int n) {
    vector <int> ans;
    if (n==1) {
        ans.push_back(1);
        return ans;
    }
    long long cur=0;
    eratosten(n);
    long long pr=find_prime(n);
    for (int i=2;i<=n;i++) {
        que[i]=lcm(1,i);
        cur=NOD(cur,que[i]);
    }
    ans.push_back(cur);
    if (cur==1) {
        for (int i=2;i<=n;i++) ans.push_back(que[i]);
        return ans;
    }
    int ind;
    if (cur==pr) ind=1;
    else {
        for (int i=2;i<=n;i++) {
            if (que[i]==cur*pr) {
                ind=i;
                break;
            }
        }
    }
    for (int i=2;i<=n;i++) {
        if (i==ind) ans.push_back(pr);
        else ans.push_back(lcm(ind,i)/pr);
    }
    return ans;
}
