#include <bits/stdc++.h>
#include "lcm.h"
using namespace std;

const int MAXN = 100000 + 5;
bool t[MAXN];
bool flag = 0;
int nn;

vector <int> G[MAXN];

long long nok(int a, int b)
{
    return (long long)a * b / __gcd(a, b);
}

void prec(int n)
{
    nn = n;
    for (int i = 1; i <= n; i++)
    {
        for (int j = 1; j <= n; j++)
        {
            if (i == j) continue;
            G[i].push_back(nok(i, j));
        }
        sort(G[i].begin(), G[i].end());
    }
}
bool used[MAXN];
int getNum(int lcm, int a)
{
    for (int b = 1; b <= nn; b++)
    {
        if (nok(a, b) == lcm && !used[b])
        {
            used[b] = 1;
            return b;
        }

    }
    return -1;
}

std::vector<int> guessPermutation(int n)
{
    for (int i = 1; i <= n; i++)
        G[i].clear();
    if (!flag) prec(n);

    for (int i = 1; i <= n; i++)
        used[i] = 0;


    vector <int> ans(n);

    vector <int> tmp;

    vector <int> lcms(n+1);

    for (int i = 2; i <= n; i++)
    {
        lcms[i] = lcm(1, i);
        tmp.push_back(lcms[i]);
    }

//    cerr << " == == " << endl;
//    for (int x: tmp) {
//        cout << x << " ";
//    }cout << endl;


    sort(tmp.begin(), tmp.end());
//
//    for (int i = 2; i <= n; i++)
//    {
//        for (int x: G[i]) {
//            cout << x << " ";
//        }cout << endl;
//    }

    for (int i = 1; i <= n; i++)
    {
        if (tmp == G[i])
        {
            ans[0] = i;
            break;
        }
    }

    for (int i = 2; i <= n; i++)
    {
        ans[i-1] = getNum(lcms[i], ans[0]);
    }
    return ans;
}
