#include<iostream>
#include<vector>
#include "lcm.h"

using namespace std;

typedef long long ll;

vector<int> prms;
bool alo[100100];

void findprms(ll n){
  for(ll i=2;i<=n;++i){
    if(alo[i])continue;
    prms.push_back(i);
    for(ll j=i+i;j<=n;j+=i)alo[j]=1;
    }
  }

ll getlrg(ll a){
  for(ll i=prms.size()-1;i>=0;--i){
    if(a%prms[i]==0)return prms[i];
    }
  }

vector<int> guessPermutation(int n){
  findprms(n);

  ll id,lgid;
  for(ll i=1,x,lg;i<=n;i+=2){
    x=lcm(i,i+1);
    lg=getlrg(x);

    if(lg>n/2){
      lgid=lg;
      if(lcm(i,i+2 > n ? i+2-n : i+2)%lg==0)id=i;
      else id=i+1;
      break;
      }
    }

  vector<int> res(n);
  for(ll i=1;i<=n;++i){
    if(i==id)res[i-1]=lgid;
    else res[i-1]=lcm(i,id)/lgid;
    }

  return res;
  }
