#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int mod = 2e9 + 7;

const ll MAX_N = 1e5 + 10;
ll arr[MAX_N];
ll n, q;

ll solve(ll l, ll r, ll p) {
    const auto eval = [&](ll x) {
        ll sum = 0;
        ll mn = mod;
        for(ll i = l; i <= r; i ++) {
            sum += max(arr[i], x);
            chkmin(mn, max(arr[i], x));
        }
        return mn * (ll)(r - l + 1) * 1000ll >= p * sum;
    };

    ll lft = 0, rght = mod;
    while(lft < rght - 1) {
        ll mid = (lft + rght) / 2ll;
        if(eval(mid)) {
            rght = mid;
        } else {
            lft = mid;
        }
    }

    ll ret = 0;
    for(ll i = l; i <= r; i ++) {
        ret += max(arr[i], rght) - arr[i];
    }
    return ret;
}

struct query {
    int l, r, p, ind;
};

struct inter {
    int l, r, ind;
};

bool operator <(const inter &a, const inter &b) {
    return a.l + a.r < b.l + b.r;
}

query all[MAX_N];
set<inter> curr, nxt;
pair<int, int> num[MAX_N];

struct seg_tree {
    int tree[4 * MAX_N];

    ll sum(int curr, int l, int r, int ql, int qr) {
        if(ql <= l && r <= qr) {
            return tree[curr];
        } else if(ql > r || qr < l) {
            return 0;
        }
        int m = (l + r) / 2ll;
        return sum(curr * 2, l, m, ql, qr) + sum(curr * 2 + 1, m + 1, r, ql, qr);
    }

    void upd(int curr, int l, int r, int ind, int val) {
        if(l == r && l == ind) {
            tree[curr] = val;
            return;
        } else if(l > ind || r < ind) {
            return;
        }
        int m = (l + r) / 2ll;
        upd(curr * 2, l, m, ind, val);
        upd(curr * 2 + 1, m + 1, r, ind, val);
    }

    void build_empty() {
        fill_n(tree, 4 * MAX_N, 0);
    }

    void build(int curr, int l, int r) {
        if(l == r) {
            tree[curr] = arr[l];
            return;
        }
        int m = (l + r) / 2ll;
        build(curr * 2, l, m);
        build(curr * 2 + 1, m + 1, r);
        tree[curr] = tree[curr * 2] + tree[curr * 2 + 1];
    }
};

seg_tree small, big;

void reset() {

}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(ll i = 0; i < n; i ++)  {
        cin >> arr[i];
        num.push_back({arr[i], i});
    }
    sort(num.begin(), num.end());

    for(int i = 0; i < q; i ++) {
        ll l, r, p;
        cin >> l >> r >> p;
        quer[i] = {l, r, p, i};
        curr.insert({0, mod, i});
    }

    while(true) {
        reset();
    }

    return 0;
}

