#include <bits/stdc++.h>
using namespace std;
#define endl "\n"
typedef long long ll;
#ifndef LOCAL
#define cerr if(false)cerr
#endif // LOCAL
template<class T, class T2> bool chkmin(T &a, const T2 &b) { return (a > b) ? a = b, 1 : 0; }
template<class T, class T2> bool chkmax(T &a, const T2 &b) { return (a < b) ? a = b, 1 : 0; }

const int mod = 2e9 + 7;

const ll MAX_N = 1e5 + 10;
ll arr[MAX_N];
ll n, q;

ll solve(ll l, ll r, ll p) {
    const auto eval = [&](ll x) {
        ll sum = 0;
        ll mn = mod;
        for(ll i = l; i <= r; i ++) {
            sum += max(arr[i], x);
            chkmin(mn, max(arr[i], x));
        }
        return x * (ll)(r - l + 1) * 1000ll >= p * sum;
    };

    ll lft = 0, rght = mod;
    while(lft < rght - 1) {
        ll mid = (lft + rght) / 2ll;
        if(eval(mid)) {
            rght = mid;
        } else {
            lft = mid;
        }
    }

    ll ret = 0;
    for(ll i = l; i <= r; i ++) {
        ret += max(arr[i], rght) - arr[i];
    }
    return ret;
}

signed main() {
#ifndef LOCAL
    ios_base::sync_with_stdio(false); cin.tie(NULL); cout.tie(NULL);
#endif // LOCAL

    cin >> n >> q;
    for(ll i = 0; i < n; i ++)  {
        cin >> arr[i];
    }

    while(q --) {
        ll l, r, p;
        cin >> l >> r >> p;
        cout << solve(l - 1, r - 1, p) << endl;
    }

    return 0;
}
