/**
    Happy birthday
    Рагадагадактак
    Рагадагадактак
*/

#include "lcm.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

int perm[MAXN];
int maxDiv[MAXN];
std::mt19937 mt(420);
std::vector <int> ans;
std::vector <int> guessPermutation(int n)
{
    ans.clear();
    ans.resize(n, -1);
    for (int i = 2 ; i < MAXN ; ++i)
    {
        if (maxDiv[i])
        {
            continue;
        }

        maxDiv[i] = i;
        for (int j = 2*i ; j < MAXN ; j += i)
        {
            maxDiv[j] = std::max(maxDiv[j], i);
        }
    }

    std::iota(perm + 1, perm + 1 + n, 1);
    std::shuffle(perm + 1, perm + 1 + n, mt);
    llong last = lcm(perm[1], perm[2]);

    int idx = -1;
    for (int i = 2 ; i < n ; ++i)
    {
        llong curr = lcm(perm[i], perm[i + 1]);
        if (maxDiv[std::__gcd(curr, last)] > n / 2)
        {
            idx = perm[i];
            ans[perm[i] - 1] = maxDiv[std::__gcd(curr, last)];
            ans[perm[i - 1] - 1] = last / ans[idx - 1];
            ans[perm[i + 1] - 1] = curr / ans[idx - 1];
            break;
        }

        last = curr;
    }

    if (idx == -1)
    {
        exit(0);
    }

    for (int i = 0 ; i < n ; ++i)
    {
        if (ans[i] == -1)
        {
            llong res =  lcm(i + 1, idx);
            ans[i] = res / ans[idx - 1];
        }
    }

    return ans;
}
