/**
    Happy birthday
    Рагадагадактак
    Рагадагадактак
*/

#include "lcm.h"
#include <algorithm>
#include <iostream>
#include <numeric>
#include <cassert>
#include <random>
#include <vector>
#include <stack>
#include <queue>
#include <set>

typedef long long llong;
const int MAXN = 10000000 + 10;
const int INF  = 1e9;

bool wasHere = false;
int perm[MAXN];
std::mt19937 mt(420);
std::vector <int> ans;

int maxDiv(llong num)
{
    int res = 0;
    for (int i = 2 ; i * i <= num ; ++i)
    {
        while (num % i == 0)
        {
            res = std::max(res, i);
            num /= i;
        }
    }

    res = std::max((llong)res, num);
    return res;
}

std::vector <int> guessPermutation(int n)
{
    ans.clear();
    ans.resize(n, -1);
    std::iota(perm + 1, perm + 1 + n, 1);
    std::shuffle(perm + 1, perm + 1 + n, mt);
    llong last = lcm(perm[1], perm[2]);

    int idx = -1;
    for (int i = 2 ; i < n ; ++i)
    {
        llong curr = lcm(perm[i], perm[i + 1]);
        int div = maxDiv(std::__gcd(curr, last));

        if (div > n / 2)
        {
            idx = perm[i];
            ans[perm[i] - 1] = div;
            ans[perm[i - 1] - 1] = last / ans[idx - 1];
            ans[perm[i + 1] - 1] = curr / ans[idx - 1];
            break;
        }

        last = curr;
    }

    if (idx == -1)
    {
        std::cout << "idx is -1\n";
        exit(0);
    }

    for (int i = 0 ; i < n ; ++i)
    {
        if (ans[i] == -1)
        {
            llong res =  lcm(i + 1, idx);
            ans[i] = res / ans[idx - 1];
        }
    }

    return ans;
}
