#include<bits/stdc++.h>
#define endl '\n'
#pragma GCC optimize("O3,unroll-loops")
#pragma GCC optimize("Ofast")
using namespace std;
const int maxn = 1e5+3;
typedef long long ll;
ll p,q,n,m,k,sum,ans,P,hodove,pos,i,j,Q,br;
vector <ll> a;
struct MST
{
    vector <int> v;
    vector <ll> sum;
} tree[4*maxn];
MST Merge(MST a,MST b)
{
    int uk1=0,uk2=0;
    int s1 = a.v.size()-1;
    int s2 = b.v.size()-1;
    MST ans;
    while(uk1<=s1 && uk2<=s2)
    {
        if(a.v[uk1]<=b.v[uk2])
        {
            ans.v.push_back(a.v[uk1]);
            uk1++;
        }
        else
        {
            ans.v.push_back(b.v[uk2]);
            uk2++;
        }
    }
    while(uk1<=s1)
    {
        ans.v.push_back(a.v[uk1]);
        uk1++;
    }
    while(uk2<=s2)
    {
        ans.v.push_back(b.v[uk2]);
        uk2++;
    }
    ans.sum.push_back(ans.v[0]);
    for(int i=1; i<ans.v.size(); i++)
        ans.sum.push_back(ans.sum[ans.sum.size()-1]+ans.v[i]);
    return ans;
}
void build(int p=1,int l=1,int r=n)
{
    //cout<<p<<" "<<l<<" "<<r<<endl;
    if(l==r)
    {
        tree[p].v.push_back(a[l]);
        tree[p].sum.push_back(a[l]);
        return ;
    }
    build(p*2,l,(l+r)/2);
    build(p*2+1,(l+r)/2+1,r);
    tree[p] = Merge(tree[p*2],tree[p*2+1]);
}
void Find(ll val,MST a)
{
    pos = lower_bound(a.v.begin(),a.v.end(),val)-a.v.begin();
    pos = min(pos,(ll)a.v.size()-1);
    if(pos<0)pos = 0;
    if(a.v[pos]>=val)///moje da nqma takiva
    {
        if(pos>0)
            sum+=a.sum[a.v.size()-1]-a.sum[pos-1];
        else
            sum+=a.sum[a.v.size()-1];
    }
    pos = lower_bound(a.v.begin(),a.v.end(),val)-a.v.begin()-1;
    pos = min(pos,(ll)a.v.size()-1);
    if(pos<0)pos = 0;
    if(pos>=0 && a.v[pos]<val)
    {
        br+=pos+1;//pos-1+1
        hodove+=(pos+1)*val - a.sum[pos];
    }
}
void query(ll val,int ql,int qr,int p=1,int l=1,int r=n)
{
    //cout<<l<<" "<<r<<endl;
    if(ql>r || l>qr)
        return ;
    if(l>=ql && r<=qr)
    {
        Find(val,tree[p]);

        return ;
    }
    query(val,ql,qr,p*2,l,(l+r)/2);
    query(val,ql,qr,p*2+1,(l+r)/2+1,r);
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    cin>>n>>Q;
    vector <ll> a;
    a.push_back(0);
    for(i=1; i<=n; i++)
    {
        cin>>p;
        a.push_back(p);
    }
    build();
    a.clear();
    a.shrink_to_fit();
    while(Q--)
    {
        int l,r;
        cin>>l>>r>>P;
        ans = LLONG_MAX;
        sum = 0;
        int ll = tree[1].v[0];
        int rr = tree[1].v[n-1];
        int mid;
        while(ll<=rr)
        {
            mid = (ll+rr)/2;
            sum = 0;
            hodove = 0;
            br = 0;
            query(mid,l,r);
           // cout<<mid<<" "<<hodove<<" "<<sum<<" "<<br<<endl;
            if(1000ll*(r-l+1)*mid>=(br*mid+sum)*P)
            {
                ans = min(ans,hodove);
                rr = mid-1;
            }
            else ll = mid+1;
        }
        cout<<ans<<endl;
    }
    /**
    while(Q--)
    {
        cin>>l>>r>>P;
        ans = LLONG_MAX;
        sum = 0;
        n = r-l+1;
        ll ll=INT_MAX,rr=0,mid;
        for(i=l;i<=r;i++)
        {
            b[i-l+1] = a[i];
            ll = min(ll,b[i-l+1]);
            rr = max(rr,b[i-l+1]);
        }

        while(ll<=rr)
        {
            mid = (ll+rr)/2;
            if(check(mid,P))
                rr = mid-1;
            else ll=mid+1;
        }
        cout<<ans<<endl;
    }
    */
    return 0;
}
/**
7 1
5 6 3 2 5 1 3
1 7 900
*/

