#include<bits/stdc++.h>
#include "lcm.h"
using namespace std;

const int MAXN=5e5+5;

int lcm_next[MAXN];
vector<int> a;
bool used[MAXN];
int perm[MAXN];

std::vector<int> guessPermutation(int n)
{
    a.resize(n);
    for(int i=1;i<n;i++)
    {
        lcm_next[i]=lcm(i,i+1);
    }
    lcm_next[0]=lcm_next[n]=lcm(1,n);

    for(int i=0;i<n;i++)
    {
        a[i]=__gcd(lcm_next[i],lcm_next[i+1]);
    }

    for(int i=1;i<=n;i++) perm[i]=i;
    bool fl=1;
    for(int i=1;i<=n;i++) used[i]=0;
    for(int i=0;i<n;i++)
    {
        if(used[a[i]]) fl=0;
        used[a[i]]=1;
    }
    while(!fl)
    {
        random_shuffle(perm+1,perm+n+1);
        for(int i=1;i<n;i+=2)
        {
            int x=lcm(perm[i],perm[i+1]);
            a[perm[i]]=__gcd(a[perm[i]],x);
            a[perm[i+1]]=__gcd(a[perm[i+1]],x);
        }

        fl=1;
        for(int i=1;i<=n;i++) used[i]=0;
        for(int i=0;i<n;i++)
        {
            if(used[a[i]]) fl=0;
            used[a[i]]=1;
        }
    }

    return a;
}
