#include<bits/stdc++.h>
using namespace std;
// (!) Не трябва да променяте дефинициите на MemoryOperation и work. В противен случай ще получите 0 точки (compilation error).

#define SET_VAL 0
#define ADD_VAL 1

#define ANSWER_CONNECTED 1
#define ANSWER_NOT_CONNECTED 2

// За да върнете резултат от work, трябва да върнете масив "std::array<MemoryOperation, 5>" с точно 5 елемента.
// Всеки елемент на масива е от тип "MemoryOperation", като всеки елемент може да се инициализира по следния начин:
// MemoryOperation(SET_VAL, 0, 1) -> създава "SET_VAL" операция на клетка 0 със стойност 1 (memory[0s] = 1)
// MemoryOperation(ADD_VAL, 0, 1) -> създава "ADD_VAL" операция на клетка 0 със стойност 1 (memory[0] += 1)

struct MemoryOperation {
    bool type;
    unsigned int addr, val;
    constexpr MemoryOperation(bool type, unsigned int addr, unsigned int val) : type(type), addr(addr), val(val) {}
};

// Функцията е constexpr, което не ви позволява да използвате глобална памет. Можете да използвате само параметрите на функцията.
constexpr std::array<MemoryOperation, 5> work(
    unsigned int u,
    unsigned int *memory,
    unsigned int memory_size,
    unsigned int *neighbours,
    unsigned int number_neighbours
) {
    unsigned int n = memory[1];
    unsigned int m = memory[2];
    int ret[5]= {};
    if( ((memory[memory_size-3]==1 && memory[memory_size-1]==0) || (memory[memory_size-3]==2 && memory[memory_size-2]==0)) && u==1  ) {
        int cnt=0;
        for(int i=3; i<memory_size; i+=5) {
            if(memory[i]==1)cnt++;
        }
        if(cnt==n)ret[0]=1;
        else ret[0]=2;
        std::array<MemoryOperation, 5> retu = {
            MemoryOperation(SET_VAL, 0, ret[0]),
            MemoryOperation(SET_VAL, memory_size-1, 0),
            MemoryOperation(SET_VAL, memory_size-2, 0),
            MemoryOperation(SET_VAL, memory_size-3, 0),
            MemoryOperation(SET_VAL, memory_size-4,0),
        };
        return retu;
    }


    ret[1]=0;
    ret[3]=0;
    ret[0]=0;
    ret[2]=0;
    ret[4]=0;
    int isupd=0;
    if(memory[(3+(u-1)*5)]==1 || u==1) {
        ret[0]=1;///is set
        isupd=0;
    } else {
        for(int i=0; i<number_neighbours; i++) {
            int v=neighbours[i];
            if(memory[3+(v-1)*5]==1) {
                isupd=1;
                ret[0]=1;
                break;
            }
        }

    }
    if(memory[memory_size-3]==0 || memory[memory_size-3]==2) {
        std::array<MemoryOperation, 5> retu = {
            MemoryOperation(SET_VAL, (3+(u-1)*5)+0, ret[0]),
            MemoryOperation(SET_VAL, (3+(u-1)*5)+1, 0),
            MemoryOperation(SET_VAL, memory_size-3, 1),
            MemoryOperation(SET_VAL, memory_size-2, 0),
            MemoryOperation(ADD_VAL, memory_size-1,isupd),
        };
        return retu;
    } else {
        std::array<MemoryOperation, 5> retu = {
            MemoryOperation(SET_VAL, (3+(u-1)*5)+0, ret[0]),
            MemoryOperation(SET_VAL, (3+(u-1)*5)+1, 0),
            MemoryOperation(SET_VAL, memory_size-3, 2),
            MemoryOperation(ADD_VAL, memory_size-2, isupd),
            MemoryOperation(SET_VAL, memory_size-1,0),
        };
        return retu;
    }
    std::array<MemoryOperation, 5> retu = {
        MemoryOperation(SET_VAL, (3+(u-1)*5)+0, ret[0]),
        MemoryOperation(SET_VAL, (3+(u-1)*5)+1, ret[1]),
        MemoryOperation(SET_VAL, memory_size-3, ret[2]),
        MemoryOperation(SET_VAL, memory_size-2, ret[3]),
        MemoryOperation(ADD_VAL, memory_size-1,ret[4]),
    };
    return retu;
}
