#include "lcm.h"
///#include "Lgrader.cpp"
#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 100000;

mt19937 rg(5021425);

int n0;
int maxp;
bool e[MAXN + 5];
bool used[MAXN + 5];

long long lcm(int i, int j);

void eratosten()
{
    e[1] = true;
    for (int i = 2; i <= n0; ++ i)
    {
        if (!e[i])
        {
            maxp = i;
            for (long long j = 1ll * i * i; j <= n0; j += i)
            {
                e[j] = true;
            }
        }
    }
}

int active, idx;

int get_unused()
{
    if (active > 2 * n0 / 3)
    {
        int i = rg() % n0 + 1;
        while (used[i]) i = rg() % n0 + 1;
        used[i] = true;
        return i;
    }
    while (used[idx]) idx++;
    used[idx] = true;
    return idx;
}

vector<int> guessPermutation(int n)
{
    n0 = n;
    eratosten();

    vector<int> v(n, 0);

    for (int i = 1; i <= n; ++ i)
    {
        used[i] = false;
    }

    idx = 1;
    active = n;

    int posmaxp = 0;
    while (active > 1)
    {
        int i = get_unused();
        int j = get_unused();
        active -= 2;
        long long q = lcm(i, j);
        if (q % maxp == 0)
        {
            int t = 1;
            while (t == i or t == j) t++;
            long long q2 = lcm(i, t);
            if (q2 % maxp == 0)
            {
                posmaxp = i;
                v[i - 1] = maxp;
                v[j - 1] = q / maxp;
                v[t - 1] = q2 / maxp;
            }
            else
            {
                posmaxp = j;
                v[j - 1] = maxp;
                v[i - 1] = q / maxp;
            }
            break;
        }
    }

    if (posmaxp == 0)
    {
        for (int i = 1; i <= n; ++ i)
        {
            if (!used[i])
            {
                posmaxp = i;
                v[i - 1] = maxp;
                break;
            }
        }
    }

    for (int i = 0; i < n; ++ i)
    {
        if (v[i] == 0) v[i] = lcm(i + 1, posmaxp) / maxp;
        ///cout << v[i] << endl;
    }

    return v;
}
