#include "lcm.h"
#include <iostream>
#include <vector>
using namespace std;
const int MAXN=1e5+10;
long long que[MAXN];
long long NOD(long long a, long long b) {
    if (a==0) return b;
    if (b==0) return a;
    return NOD(b,a%b);
}
vector <int> guessPermutation(int n) {
    vector <int> ans;
    if (n==1) {
        ans.push_back(1);
        return ans;
    }
    long long cur=0;
    if (n==10) pr=7;
    else if (n==100) pr=97;
    else if (n==1000) pr=997;
    else if (n==10000) pr=9973;
    else pr=99991;
    for (int i=2;i<=n;i++) {
        que[i]=lcm(1,i);
        cur=NOD(cur,que[i]);
    }
    ans.push_back(cur);
    if (cur==1) {
        for (int i=2;i<=n;i++) ans.push_back(que[i]);
        return ans;
    }
    int ind;
    if (cur==pr) ind=1;
    else {
        for (int i=2;i<=n;i++) {
            if (que[i]==cur*pr) {
                ind=i;
                break;
            }
        }
    }
    for (int i=2;i<=n;i++) {
        if (i==ind) ans.push_back(pr);
        else ans.push_back(lcm(ind,i)/pr);
    }
    return ans;
}
