#include <bits/stdc++.h>
#include "lcm.h"
using namespace std;

map <pair<int,int>, long long> mp;

long long getLCM(int i, int j)
{
    if (mp[{i, j}]) return mp[{i, j}];
    return mp[{i, j}] = lcm(i, j);
}

std::vector<int> guessPermutation(int n)
{
    mp.clear();
    for (int i = 1; i <= n; i++)
    {
        vector <int> used(n+1, 0);
        vector <int> ans;
        bool fl = 1;
        for (int j = 1; j <= n; j++)
        {
            if (i == j)
            {
                ans.push_back(1);
                continue;
            }
            long long res = getLCM(i, j);
            if (res > n || used[res])
            {
                fl = 0;
                break;
            }
            ans.push_back(res);
            used[res] = 1;
        }
        if (fl)
        {
            return ans;
        }
    }

}
